=== examples/hpddm/CMakeLists.txt ===
FILE(GLOB EDP_FILES *.edp)
FOREACH(EDP_FILE ${EDP_FILES})
  GET_FILENAME_COMPONENT(FILENAME ${EDP_FILE} NAME_WE)
  ADD_TEST(NAME ${FILENAME} COMMAND "${CMAKE_BINARY_DIR}/src/FreeFem++" ${EDP_FILE})
ENDFOREACH(EDP_FILE)
