=== debian/changelog ===
freefem++ (4.9+dfsg1-2build1) jammy; urgency=medium

  * No-change rebuild against libgsl27

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 07 Dec 2021 17:30:06 +0000

freefem++ (4.9+dfsg1-2) unstable; urgency=medium

  * Fix blhc false positive with ff-c++ 
  * Fix invalid uploader (Closes: #992381)
  * Configure with --enable-generic to fix baseline violation
    (Closes: #924009)

 -- Francois Mazen <francois@mzf.fr>  Tue, 17 Aug 2021 22:45:22 +0200

freefem++ (4.9+dfsg1-1) unstable; urgency=medium

  * New upstream version (Closes: #969022)
  * Bump standard version to 4.5.1
  * Set debhelper-compat to 13
  * Set Rules-Requires-Root to no
  * Remove trailing whitespaces
  * Set secure url in copyright file
  * Remove obsolete patches
  * Fix native encoding of some files
  * Fix missing hardening flags
  * Add man page for ffmaster
  * Fix file path in ffmaster
  * Add upstream metadata
  * Add missing dependency (unzip)
  * Fix config.h PACKAGE_NAME collision by using AX_PREFIX_CONFIG_H
  * Add auto package tests
  * Add debian/clean file
  * Add Francois Mazen as uploader

 -- Francois Mazen <francois@mzf.fr>  Fri, 21 May 2021 22:23:38 +0200

freefem++ (3.61.1+dfsg1-6) unstable; urgency=high

  * Team upload.
  * Fix FTBFS with GCC-10 (Closes: #957233)

 -- Francois Mazen <francois@mzf.fr>  Thu, 13 May 2021 14:06:33 +0200

freefem++ (3.61.1+dfsg1-5.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix FTBFS with gsl 2.6 (Closes: #960010)

 -- Stefano Rivera <stefanor@debian.org>  Sun, 17 May 2020 13:41:04 -0700
