## freefem++ 4.11+dfsg1

=== examples/CMakeLists.txt ===

ADD_SUBDIRECTORY(misc)
ADD_SUBDIRECTORY(3d)
ADD_SUBDIRECTORY(3dSurf)
ADD_SUBDIRECTORY(examples)
ADD_SUBDIRECTORY(eigen)
#ADD_SUBDIRECTORY(plugin)
ADD_SUBDIRECTORY(mpi)
ADD_SUBDIRECTORY(other)
ADD_SUBDIRECTORY(tutorial)
ADD_SUBDIRECTORY(ffddm)
