=== src/bamglib/CMakeLists.txt ===
FILE(GLOB_RECURSE CPPFILES *.cpp)
LIST(REMOVE_ITEM CPPFILES ${CMAKE_SOURCE_DIR}/src/bamglib/Meshgibbs.cpp)
ADD_LIBRARY(bamglib ${CPPFILES})
INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR}/src/fflib)
