=== debian/changelog ===
freefem++ (4.11+dfsg1-3) unstable; urgency=high

  * Add allow-stderr restriction for build-and-run-lib (Closes: #1033702)

 -- Francois Mazen <francois@mzf.fr>  Sat, 08 Apr 2023 15:19:26 +0200

freefem++ (4.11+dfsg1-2) unstable; urgency=medium

  * Limit autopkgtest architectures to allow testing migration (Closes:
    #992924)

 -- Francois Mazen <francois@mzf.fr>  Sun, 17 Apr 2022 14:09:49 +0200

freefem++ (4.11+dfsg1-1) unstable; urgency=medium

  * New upstream version
  * Update debian/copyright for automatic repack
  * Bump standard version to 4.6.0.1

 -- Francois Mazen <francois@mzf.fr>  Sat, 09 Apr 2022 21:11:07 +0200
