=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: freefem++
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Christophe Trophime <christophe.trophime@lncmi.cnrs.fr>,
            Dimitrios Eftaxiopoulos <eftaxi12@otenet.gr>,
            Francois Mazen <francois@mzf.fr>
@@ -52,7 +51,7 @@
 # libparms2-dev, libitsol-dev,
 # libhips-dev, libpastix-dev,
 # libsuperlu-dist-dev
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0.1
 Vcs-Browser: https://salsa.debian.org/science-team/freefempp
 Vcs-Git: https://salsa.debian.org/science-team/freefempp.git
 Homepage: http://www.freefem.org/ff++/
