=== debian/tests/control ===
--- 
+++ 
@@ -7,3 +7,5 @@
 
 Tests: build-and-run-lib
 Depends: libfreefem++-dev, freefem++, build-essential
+Restrictions: allow-stderr
+Architecture: amd64, armhf, i386
